*=$1600   ;

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                Lightgun related routines
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;-------------------------------------------------------------------------------
; use this routine before calling starting the actual game
;
;   JSR CALLIBRATE_LIGHTGUN
;-------------------------------------------------------------------------------

CALLIBRATE_LIGHTGUN
                        LDA #$0                 ;0=black, 1=white, etc.
                        STA COL_PRINT           ;set printing color
                        JSR CLEARSCREEN         ;

                        LDA #15                 ;set background and border colour
                        STA BORDER              ;poke x in 53280,x (bordercolour)
                        STA BACKGROUND          ;poke x in 53281,x (background-0)
                        LDA #0                  ;
                        STA BACKGROUND1         ;this is the color of the text (with the char we are using)
                        LDA #1                  ;green
                        STA BACKGROUND2         ;
                        LDA #11                 ;grey
                        STA BACKGROUND3         ;
              
                        LDX #0                  ;write the window that holds the diagnostic/measured values
                        LDY #0                  ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_01       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_01       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        LDA #$1                 ;0=black, 1=white, etc.
                        STA COL_PRINT           ;set printing color
                        LDX #0                  ;write the target to screen
                        LDY #11                 ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_02       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_02       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        LDA #$0                 ;0=black, 1=white, etc.
                        STA COL_PRINT           ;set printing color
                        LDX #0                  ;write the instructions
                        LDY #23                 ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_03       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_03       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        LDA #%00000001          ;sprite 0-7 enable/disable register (1=enable)
                        STA $D015               ;

                        JMP CL_LP_02

CL_LP_01                LDA #$00                ;
                        STA LIGHTGUN_X_OFFSET   ;clear the lightguns offset value
                        STA LIGHTGUN_Y_OFFSET   ;clear the lightguns offset value
                        JSR GET_LIGHTGUN_POS    ;

                        ;calculate the offset values
                        ;---------------------------

                        LDA LIGHTGUN_RAW_X      ;
                        CLC                     ;
                        SBC #89                 ;the reference X-position
                        STA LIGHTGUN_X_OFFSET   ;

                        LDA LIGHTGUN_RAW_Y      ;
                        CLC                     ;
                        SBC #147                ;the reference Y-position
                        STA LIGHTGUN_Y_OFFSET   ;


CL_LP_02                LDX #3                  ;
                        LDY #3                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_RAW_X      ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #9                  ;
                        LDY #3                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_RAW_Y      ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #29                 ;
                        LDY #3                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_X_OFFSET   ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #35                 ;
                        LDY #3                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_Y_OFFSET   ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes
        
                        JSR CHECK_TRIGGER       ;check if the trigger of the lightgun has been pulled
                        BCS CL_LP_01            ;use current value until the fire button has been pressed
                        JSR GET_LIGHTGUN_POS    ;
                        LDA #$0                 ;clear port to enable crude keyboard readout
                        STA $DC00               ;now control-port 1 is selected for reading the POT registers
                        LDA DATAPORTB           ;check keyboard inputs
                        CMP #$7F                ;STOP-key pressed?
                        BEQ CL_LP_EXIT          ;

                        JMP CL_LP_02            ;STOP-key is not pressed, keep looping

CL_LP_EXIT              RTS                     ;



TXT_CALL_01
; Screen 3 - Callibrate lightgun
; Screen 3 - Screen_callibrate
        BYTE    $55,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$49,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$55,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$49
        BYTE    $5D,$20,$20,$10,$0F,$13,$09,$14,$09,$0F,$0E,$20,$20,$5D,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5D,$20,$20,$20,$0F,$06,$06,$13,$05,$14,$20,$20,$20,$5D
        BYTE    $6B,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$73,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6B,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$73
        BYTE    $5D,$18,$3A,$20,$20,$20,$20,$19,$3A,$20,$20,$20,$20,$5D,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5D,$18,$3A,$20,$20,$20,$20,$19,$3A,$20,$20,$20,$20,$5D
        BYTE    $4A,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$4B,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$4A,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$4B
        BYTE 0


TXT_CALL_02
        BYTE    $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$71,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE    $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$73,$7B,$6B,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE    $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$72,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE 0

TXT_CALL_03  ;0123456789012345678901234567890123456789
        TEXT '     aim lightgun and press trigger     '
        TEXT '    use run/stop to exit this screen'
        BYTE 0





;-------------------------------------------------------------------------------
; use this routine to get the X and Y position of the lightgun
; (this requires the callibration values to be set by the CALLIBRATE_LIGHTGUN routine)
; this routine will move SPRITE-0 to the position that the lightgun points at
;
;   JSR GET_LIGHTGUN_POS
;-------------------------------------------------------------------------------

GET_LIGHTGUN_POS        LDA $D013               ;pen X
                        STA LIGHTGUN_RAW_X      ;save the current lightpen X-position
                        CLC                     ;
                        SBC LIGHTGUN_X_OFFSET   ;subtract X offset
                        PHA                     ;save result
                        CLC                     ;
                        ROL                     ;effectively multiply by two
                        STA LIGHTGUN_X          ;save the calibrated lightpen X-position
                        PLA
                        SEC                     ;
                        SBC #5                  ;the center of the crosshair is shifted ... pixels right
                        CLC                     ;
                        ROL                     ;effectively multiply by two
                        STA $D000               ;sprite-0 position X
                        BCS GLP_SPR_POS_0       ;
                        LDA $D010               ;get current value
                        AND #%11111110          ;clear 9th X-position bit of sprite 0
                        JMP GLP_SPR_POS_1       ;
GLP_SPR_POS_0           LDA $D010               ;get current value
                        ORA #%00000001          ;set 9th X-position bit of sprite 0              
GLP_SPR_POS_1           STA $D010               ;

                        LDA $D014               ;pen Y
                        STA LIGHTGUN_RAW_Y      ;save the current lightpen Y-position
                        CLC                     ;
                        SBC LIGHTGUN_Y_OFFSET   ;subtract Y offset
                        STA LIGHTGUN_Y          ;save the calibrated lightpen Y-position
                        SEC                     ;
                        SBC #8                  ;the center of the crosshair is shifted ... pixels down
                        STA $D001               ;sprite-0 position Y

                        RTS                     ;

;===================================================================
;JSR CHECK_TRIGGER      ;checks if the trigger line has been activated
;C=0 when no trigger is pulled (no trigger activity)
;C=1 when trigger is pulled (the user shoots his gun)
;===================================================================
CHECK_TRIGGER   LDA $DC01                       ;
                AND #%00000100                  ;check for fire button of Stack Light Rifle
                BEQ CHECK_TR_STACK              ;trigger of Stack light rifle detected

                LDA $DC00                       ;Control-Port 1 selected         bit6=0 and bit7=1
                AND #%00111111                  ;clear bit-6
                ORA #%10000000                  ;set bit-7
                STA $DC00                       ;now control-port 1 is selected for reading the POT registers
                LDA $D41A                       ;Paddle Y value  0..255 ($D419=Paddle X value  0..255 )
                CMP #$0                         ;
                BEQ CHECK_TR_MAGNUM             ;trigger of magnum detected

                CLC                             ;clear carry to indicate that the trigger has not been pulled
                RTS                             ;no trigger pulled, exit routine

CHECK_TR_STACK  LDA $DC01                       ;
                AND #%00000100                  ;check for fire button of Stack Light Rifle
                BEQ CHECK_TR_STACK              ;keep looping until released
                SEC                             ;set carry to indicate that the trigger has been pulled
                RTS                             ;return to the calling routine

CHECK_TR_MAGNUM LDA $D41A                       ;Paddle Y value  0..255 ($D419=Paddle X value  0..255 )
                CMP #$0                         ;keep looping until released
                BEQ CHECK_TR_MAGNUM             ;
                SEC                             ;set carry to indicate that the trigger has been pulled
                RTS                             ;return to the calling routine

;===================================================================
;JSR CHECK_HAMMER      ;checks if the hammer is detecting a hit
;C=0 when hammer is idle (no trigger activity)
;C=1 when hammer hits something hard (the user hits the screen)
;===================================================================
CHECK_HAMMER    CLC                             ;clear carry to indicate that the trigger has not been pulled
                LDA $DC01                       ;
                AND #%00000100                  ;check for fire button of Stack Light Rifle
                BEQ CHECK_HAM_END               ;no signal, exit routine

CHECK_HAM_01    LDA $DC01                       ;
                AND #%00000100                  ;check for fire button of Stack Light Rifle
                BNE CHECK_HAM_01                ;no signal pulled, exit routine
                            
                SEC                             ;set carry to indicate that the trigger has been pulled
CHECK_HAM_END   RTS                             ;return to the calling routine


;===============================================================================
;This routine will convert the current sprite position-0 into a location of the
;screen memory, then it reads that value and it is returned in A.
;Why sprite-0, well simply because sprite-0 is usefull for a crosshair or pointer
;and since that is an important item, why not use the very first available sprite
;for it? At least I thought it made sense...

SPRITECHARVAL   LDA $D000       ;the sprite we want the char position of
                LSR             ;make room for 9th bit
                STA CHR_COLUMN  ;store to register (this is not the result!)

                LDA $D010       ;sprite 0-7 9th bit of X-coordinate
                AND #%00000001  ;use LSB (sprite-0)
                CLC             ;            
                ROR             ;moves BIT-0 to Carry
                ROR             ;moves carry to BIT-7
                ADC CHR_COLUMN  ;add the 9th bit of the sprite pos
                STA CHR_COLUMN  ;               
                
                TXA             ;get offset value
                LSR             ;offset divided by 2 (because we also devided the sprite position by 2 earlier)
                CLC             ;prepare to add
                ADC CHR_COLUMN  ;add the offset
                SEC             ;            
                SBC #12         ;the first 24 pixels (which is now 2 because we divided by 2 earlier) of the sprite's X are outside the visible area 
                LSR             ;shift 2x to the right for a total division of 8 (each char is 8 pixels)
                LSR             ;

                CMP #41         ;make sure that column value does not exceed the allowable range
                BCC SCRVAL_01   ;
                LDA #40         ;
SCRVAL_01       STA CHR_COLUMN  ;this reg. holds the char column (or the X position)

                LDA $D001       ;the sprite we want the char position of
                SEC             ;            
                SBC #50         ;the first 50 pixels of the sprite's Y are outside the visible area
                STA CHR_ROW     ;save to register, this is not the end value!
                TYA             ;get offset
                CLC             ;prepare to add
                ADC CHR_ROW     ;add the offset 
                LSR             ;shift 3x to the right is the same a division by 8 (each char is 8 pixels)
                LSR             ;
                LSR             ;

                CMP #26         ;make sure that column value does not exceed the allowable range
                BCC SCRVAL_02   ;
                LDA #25         ;
SCRVAL_02       STA CHR_ROW     ;this reg. holds the char row (or the Y position)


;this routine calculates the character address based on the given COLUMN and ROW
CALC_CHR_ADR    LDA #<CHARSCREEN        ;
                STA CHAR_ADDR           ;store base address (low byte)
                LDA #>CHARSCREEN        ;
                STA CHAR_ADDR+1         ;store base address (high byte)

CALC_CA_01      CLC                     ;
                LDA CHR_COLUMN          ;
                ADC CHAR_ADDR           ;
                STA CHAR_ADDR           ;save result of add
                BCC CALC_CA_02          ;check for carry
                INC CHAR_ADDR+1         ;carry detected, increase high byte of char address

CALC_CA_02      LDA CHR_ROW             ;check if not 0
                BEQ CALC_CA_END         ;when it is 0, we are done with the calculation

CALC_CA_03      CLC                     ;
                LDA #40                 ;40 characters per line, so for each column we must add 40 chars to our address counter
                ADC CHAR_ADDR           ;
                STA CHAR_ADDR           ;save result of add
                BCC CALC_CA_04          ;check for carry
                INC CHAR_ADDR+1         ;carry detected, increase high byte of char address
CALC_CA_04      DEC CHR_ROW             ;
                BNE CALC_CA_03          ;

CALC_CA_END     
GET_SCREENVALUE LDY #$00
       ;        LDA #186                ;debug: print a special char at the calculated
       ;        STA (CHAR_ADDR),Y       ;location on the screen, so we can see if it is the correct one
                LDA (CHAR_ADDR),Y       ;
                CLC                     ;clear carry (everything=OK)
                RTS

CHR_ROW         BYTE $00
CHR_COLUMN      BYTE $00